<?php


























class MemberUserSexExtendedField extends AbstractMemberExtendedField
{
public function __construct()
{
parent::__construct();
$this->set_disable_fields_configuration(array('regex','possible_values','default_values'));
$this->set_name(LangLoader::get_message('type.user-sex','admin-extended-fields-common'));
$this->field_used_once=true;
$this->field_used_phpboost_config=true;
}

public function display_field_create(MemberExtendedField $member_extended_field)
{
$fieldset=$member_extended_field->get_fieldset();

$fieldset->add_field(new FormFieldSimpleSelectChoice($member_extended_field->get_field_name(),$member_extended_field->get_name(),'0',
array(
new FormFieldSelectChoiceOption('--',''),
new FormFieldSelectChoiceOption(LangLoader::get_message('male','main'),'1'),
new FormFieldSelectChoiceOption(LangLoader::get_message('female','main'),'2'),
),
array('description'=>$member_extended_field->get_description(),'required'=>(bool)$member_extended_field->get_required())
));
}

public function display_field_update(MemberExtendedField $member_extended_field)
{
$fieldset=$member_extended_field->get_fieldset();

$fieldset->add_field(new FormFieldSimpleSelectChoice($member_extended_field->get_field_name(),$member_extended_field->get_name(),$member_extended_field->get_value(),
array(
new FormFieldSelectChoiceOption('--',''),
new FormFieldSelectChoiceOption(LangLoader::get_message('male','main'),'1'),
new FormFieldSelectChoiceOption(LangLoader::get_message('female','main'),'2'),
),
array('description'=>$member_extended_field->get_description(),'required'=>(bool)$member_extended_field->get_required())
));
}

public function display_field_profile(MemberExtendedField $member_extended_field)
{
$fieldset=$member_extended_field->get_fieldset();
$value=$member_extended_field->get_value();
if($value!==null)
{
$fieldset->add_field(new FormFieldFree($member_extended_field->get_field_name(),$member_extended_field->get_name(),$this->get_picture_sex($value)));
}
}

public function return_value(HTMLForm $form,MemberExtendedField $member_extended_field)
{
$field_name=$member_extended_field->get_field_name();
if($form->has_field($field_name))
return $form->get_value($field_name)->get_raw_value();

return '';
}

private function get_picture_sex($value)
{
switch($value)
{
case 1:
return '<img src="'.TPL_PATH_TO_ROOT.'/templates/'.get_utheme().'/images/man.png" />';
break;
case 2:
return '<img src="'.TPL_PATH_TO_ROOT.'/templates/'.get_utheme().'/images/woman.png" />';
break;
default:
return '';
}
}
}
?>